//+------------------------------------------------------------------+
//|                                                      EA pCCI.mq5 |
//|                                                        AIS Forex |
//|                        https://www.mql5.com/en/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "AIS Forex"
#property link      "https://www.mql5.com/en/users/aleksej1966"
#property version   "1.00"

sinput int Magic=25072022;
sinput double Lot=0;

enum type_ind {Classical,Square,Modern};
input type_ind TypeInd=Classical;
input ushort iPeriod=14;
input ENUM_APPLIED_PRICE iPrice=PRICE_TYPICAL;
input ushort iLevel=70;

int indx10,indx11,indx20,indx21,length=3,level=1;
double lot,halfsums[],diff[];
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   lot=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);
   double lots=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_STEP);
   lot=MathMin(lot+MathMax(0,MathRound((Lot-lot)/lots))*lots,SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX));

   length=MathMax(length,iPeriod);
   level=(uchar)MathMin(MathMax(iLevel,level),99);

   if(TypeInd==Modern)
     {
      int sizeHS=length*(length-1)/2;
      ArrayResize(halfsums,sizeHS);
      indx10=sizeHS/2;
      indx11=MathMod(sizeHS,2)==0? indx10-1:indx10;
      ArrayResize(diff,length);
      indx20=length/2;
      indx21=MathMod(length,2)==0? indx20-1:indx20;
     }

   int bars=iPrice==PRICE_OPEN? iBars(_Symbol,PERIOD_CURRENT)-length-1:iBars(_Symbol,PERIOD_CURRENT)-length-2;
   for(int i=bars; i>=0; i--)
      CalcularionIndicator(i);

   NewBar();
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
//---
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   if(NewBar()==true)
     {
      int signal=CalcularionIndicator(0);
      if(signal==0)
         PutPosition(ORDER_TYPE_BUY);
      if(signal==1)
         PutPosition(ORDER_TYPE_SELL);
     }
//---
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void PutPosition(ENUM_ORDER_TYPE type)
  {
//---
   double price=type==ORDER_TYPE_BUY? SymbolInfoDouble(_Symbol,SYMBOL_ASK):SymbolInfoDouble(_Symbol,SYMBOL_BID),margin;
   if(OrderCalcMargin(type,_Symbol,lot,price,margin)==false)
      return;
   if(margin>AccountInfoDouble(ACCOUNT_MARGIN_FREE))
     {
      Print("Not enough money for ",EnumToString(type)," ",lot," ",_Symbol," Error code=",GetLastError());
      return;
     }
   MqlTradeRequest request= {};
   MqlTradeResult result= {};
   request.action=TRADE_ACTION_DEAL;
   request.magic=Magic;
   request.symbol=_Symbol;
   request.volume=lot;
   request.price=price;
   request.deviation=MathMax(SymbolInfoInteger(_Symbol,SYMBOL_SPREAD)/2,3);
   request.type=type;
   if(OrderSend(request,result)==false)
      PrintFormat("OrderSend error %d",GetLastError());
//---
   for(int pos=PositionsTotal()-1; pos>=0; pos--)
     {
      ulong ticket=PositionGetTicket(pos);
      if(ticket>0 && PositionSelectByTicket(ticket)==true && PositionGetInteger(POSITION_MAGIC)==Magic && PositionGetString(POSITION_SYMBOL)==_Symbol)
        {
         if(type==ORDER_TYPE_SELL && PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
            ClosePosition(POSITION_TYPE_BUY,ticket);
         if(type==ORDER_TYPE_BUY && PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
            ClosePosition(POSITION_TYPE_SELL,ticket);
        }
     }
//---
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ClosePosition(ENUM_POSITION_TYPE type_pos,ulong ticket)
  {
//---
   MqlTradeRequest request= {};
   MqlTradeResult result= {};
   request.action=TRADE_ACTION_DEAL;
   request.position=ticket;
   request.symbol=_Symbol;
   request.volume=lot;
   request.deviation=MathMax(SymbolInfoInteger(_Symbol,SYMBOL_SPREAD)/2,3);
   if(type_pos==POSITION_TYPE_BUY)
     {
      request.price=SymbolInfoDouble(_Symbol,SYMBOL_BID);
      request.type=ORDER_TYPE_SELL;
     }
   else
     {
      request.price=SymbolInfoDouble(_Symbol,SYMBOL_ASK);
      request.type=ORDER_TYPE_BUY;
     }
   if(OrderSend(request,result)==false)
      PrintFormat("OrderSend error %d",GetLastError());
//---
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
char CalcularionIndicator(int num_bar)
  {
//---
   static int array_dn[],size_dn,array_up[],size_up;
   static double last_cci;

   if(size_dn==0)
      ArrayResize(array_up,size_up,1000);
   if(size_up==0)
      ArrayResize(array_dn,size_dn,1000);

   int pos=iPrice==PRICE_OPEN? num_bar:num_bar+1;

   double cci=0;
   if(TypeInd==Classical)
     {
      double mean=0,mad=0;
      for(int i=0; i<length; i++)
         mean=mean+CPrice(pos+i);
      mean=mean/length;
      for(int i=0; i<length; i++)
         mad=mad+MathAbs(CPrice(pos+i)-mean);
      cci=length*(CPrice(pos)-mean)/mad;
     }
//---
   if(TypeInd==Square)
     {
      double sumS=0,sumQ=0;
      for(int i=0; i<length; i++)
        {
         double p=CPrice(pos+i);
         sumS=sumS+p;
         sumQ=sumQ+p*p;
        }
      cci=(CPrice(pos)-sumS/length)*MathSqrt(length*sumQ-sumS*sumS)/length;
     }
//---
   if(TypeInd==Modern)
     {
      int cnt=0;
      for(int i=length-2; i>=0; i--)
        {
         double p=CPrice(pos+i);
         for(int j=length-1; j>i; j--)
           {
            halfsums[cnt]=p+CPrice(pos+j);
            cnt++;
           }
        }
      ArraySort(halfsums);
      double mean=(halfsums[indx10]+halfsums[indx11])/4;
      for(int i=0; i<length; i++)
         diff[i]=MathAbs(CPrice(pos+i)-mean);
      ArraySort(diff);
      cci=(CPrice(pos)-mean)*(diff[indx20]+diff[indx21])/2;
     }

   if(cci>0)
     {
      ArrayResize(array_up,size_up+1);
      array_up[size_up]=(int)MathRound(cci/_Point);
      size_up++;
     }
   if(cci<0)
     {
      ArrayResize(array_dn,size_dn+1);
      array_dn[size_dn]=(int)MathRound(-cci/_Point);
      size_dn++;
     }

   if(num_bar==0)
     {
      ArraySort(array_up);
      ArraySort(array_dn);
      double lvl_up=array_up[size_up*level/100]*_Point,lvl_dn=-array_dn[size_dn*level/100]*_Point;

      if(cci>=lvl_up && last_cci>=cci)
         return(1);

      if(cci<=lvl_dn && last_cci<=cci)
         return(0);
     }

   last_cci=cci;
   return(-1);
//---
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CPrice(int i)
  {
//---
   if(iPrice==PRICE_CLOSE)
      return(iClose(_Symbol,PERIOD_CURRENT,i));
   if(iPrice==PRICE_OPEN)
      return(iOpen(_Symbol,PERIOD_CURRENT,i));
   if(iPrice==PRICE_HIGH)
      return(iHigh(_Symbol,PERIOD_CURRENT,i));
   if(iPrice==PRICE_LOW)
      return(iLow(_Symbol,PERIOD_CURRENT,i));
   if(iPrice==PRICE_MEDIAN)
      return((iHigh(_Symbol,PERIOD_CURRENT,i)+iLow(_Symbol,PERIOD_CURRENT,i))/2);
   if(iPrice==PRICE_TYPICAL)
      return((iHigh(_Symbol,PERIOD_CURRENT,i)+iLow(_Symbol,PERIOD_CURRENT,i)+iClose(_Symbol,PERIOD_CURRENT,i))/3);
   return((iHigh(_Symbol,PERIOD_CURRENT,i)+iLow(_Symbol,PERIOD_CURRENT,i)+2*iClose(_Symbol,PERIOD_CURRENT,i))/4);
//---
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool NewBar()
  {
//---
   static long last_bar;
   long cur_bar=SeriesInfoInteger(_Symbol,PERIOD_CURRENT,SERIES_LASTBAR_DATE);
   if(last_bar<cur_bar)
     {
      last_bar=cur_bar;
      return(true);
     }
   return(false);
//---
  }
//+------------------------------------------------------------------+
